/**
* Xelfi programming environment
*/

package xelfi.browser.document;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import xelfi.editor.EndOfTextException;

/**
* This class
*
* @version 1.0
* @author Jan Jancura
*/
public class BrClass extends BrObject
{
    public String               extendsModifier;
    public String[]             implementsModifier;
    public boolean              isForm;

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public BrClass(
                MyPosition pPositionB,
                MyPosition pPositionE,
                MyPosition pCommentPositionB,
                MyPosition pCommentPositionE,
                BrPackage pPackage,
                String pName,
                XFile pXFile,
                Modifiers modifiers,

                String pExtends,
                String[] pImplements,
                boolean form)
    {
        super(pPositionB,pPositionE,pCommentPositionB,pCommentPositionE,
            pPackage,pName,pXFile,modifiers);

        extendsModifier = pExtends;
        implementsModifier = pImplements;
        isForm = form;
        initFlags();
        return;
    }
    private void initFlags()
    {
        //flags
        StringBuffer s = new StringBuffer(10);
        s.append(isForm ? 'f' : 'c').
        append(modifiers.abstractM() ? 'a' : '-').
        append(modifiers.finalM() ? 'f' : '-' ).
        append(modifiers.access()).
        append(' ');
        flags = new String(s);
        return;
    }
    BrClass(BrPackage pkg,DataInputStream is,boolean pForm)
        throws IOException
    {
        super(pkg,is);
        extendsModifier = is.readUTF();
        int i,k = is.readChar();
        implementsModifier = new String[k];
        for(i=0;i<k;i++)
            implementsModifier[i] = is.readUTF();

        isForm = pForm;
        initFlags();
        return;
    }
    void save1(DataOutputStream os) throws EndOfTextException,
        IOException
    {
        super.save1(os);
        os.writeUTF(extendsModifier);
        os.writeChar(implementsModifier.length);
        int i,k = implementsModifier.length;
        for(i=0;i<k;i++)
        {
            os.writeUTF(implementsModifier[i]);
        }
        return;
    }
   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public String getParent()
    {
        return extendsModifier;
    }

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public String getText()
    {
        StringBuffer b = new StringBuffer();
        switch( modifiers.access() )
        {
        case 0: b.append("public ");break;
        case 2: b.append("private ");break;
        case 3: b.append("protected ");break;
        }
        b.append(modifiers.abstractM() ? "abstract " : "").
        append(modifiers.finalM() ? "final " : "").

        append("class ").
        append(name).append(" ");

        if( (extendsModifier != null) &&
                (extendsModifier.length() > 0) )
            b.append(" extends ").
            append(extendsModifier);

        int k;
        if( (k = implementsModifier.length) > 0 )
        {
            b.append(" implements ").
            append(implementsModifier[0]);
            int i;
            for(i=1;i<k;i++)
                b.append(", ").
                append(implementsModifier[i]);
        }
        return new String(b);
    }
}









