/**
* Xelfi programming environment
*/

package xelfi.browser.document;

import java.util.Date;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import xelfi.editor.*;

import java.io.InputStream;

/**
* This class
*
* @version 1.0
* @author Jan Jancura
*/
public class BrInterface extends BrObject
{

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public String[]    extendsModifier;

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public BrInterface(
                MyPosition pPositionB,
                MyPosition pPositionE,
                MyPosition pCommentPositionB,
                MyPosition pCommentPositionE,
                BrPackage pPackage,
                String pName,
                XFile pXFile,
                Modifiers modifiers,

                String[] pExtends)
    {
        super(pPositionB,pPositionE,pCommentPositionB,pCommentPositionE,
            pPackage,pName,pXFile,modifiers);

        extendsModifier = pExtends;
        flags = "i" + "--" + modifiers.access() + " ";
        return;
    }
    void save1(DataOutputStream os) throws EndOfTextException, IOException
    {
        super.save1(os);
        os.writeChar(extendsModifier.length);
        int i,k = extendsModifier.length;
        for(i=0;i<k;i++)
        {
            os.writeUTF(extendsModifier[i]);
        }
        return;
    }
    BrInterface(BrPackage pkg,DataInputStream is)
        throws IOException
    {
        super(pkg,is);
        int i,k = is.readChar();
        extendsModifier = new String[k];
        for(i=0;i<k;i++)
            extendsModifier[i] = is.readUTF();

        flags = "i" + "--" + modifiers.access() + " ";

        return;
    }
   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public String getText()
    {
        StringBuffer b = new StringBuffer();

        b.append(modifiers.publicM() ? "public " : "").
        append(modifiers.abstractM() ? "abstract " : "").

        append("interface ").
        append(name);
        int k;
        if( (k = extendsModifier.length) > 0 )
        {
            b.append(" ").
            append(extendsModifier[0]);
            int i;
            for(i=1;i<k;i++)
                b.append(", ").
                append(extendsModifier[i]);
        }
        return new String(b);
    }
    public String getHint()
        throws IOException
    {
        if( commentPositionB == null )
        {
            return "This interface \n\n@see \n@version 1.0\n" +
                "@author \n";
        }else
        {
            Source src = new Source(getXFile());
            InputStream is = (new Block(commentPositionB.getPosition(),
                commentPositionE.getPosition())).
                getInputStream();
            StringBuffer b = new StringBuffer();
            int c;
            while( (c = is.read()) >= 0 ) b.append((char)c);
            String s = new String(b);

            return hintToString(s);
        }
    }

}











