
package xelfi.browser.view;

import java.awt.*;
import java.io.FileNotFoundException;
import java.io.IOException;
import xelfi.browser.document.*;
import xelfi.browser.util.*;

public class PackageView extends xelfi.top.TopDialog implements modalObject
{
    // Visual Data
    TextField       editName;
    TextField       editPath;
    Button          buttonChange;
    Button          buttonNew;
    Button          buttonDel;
    Button          buttonCopy;
    Button          buttonPaste;
    Button          buttonCut;
    Button          buttonOpen;
    Button          buttonReparse;
    Button          buttonCancel;

    // Non-Visual Data
    BrPackage       pkg;
    String          pomStr;

    boolean         chImplementsStatement;
    boolean         chPackageStatement;

    public PackageView(Frame f,BrPackage p)
    {
        super(f,"Package view",true);
        pkg = p;

        setLayout(new HorizLayout(HorizLayout.RESIZE,HorizLayout.CENTER));
        addNotify();

        Label l = new Label("");
        switch(p.getProject())
        {
        case 1: l = new Label("Project package:");
            break;
        case 2: l = new Label("System package:");
            break;
        }
        add(l);

        editName = new TextField(p.name);
        add(editName);

        l = new Label("Path:");
        add(l);

        editPath = new TextField(p.getXFile().getPathStr());
        editPath.disable();
        add(editPath);

        buttonChange = new Button("Change name");
        add(buttonChange);

        buttonNew = new Button("New package");
        add(buttonNew);

        //buttonDel = new Button("Delete package");
        //add(buttonDel);

        Panel pp = new Panel();
        pp.setLayout(new VertLayout());
        add(pp);

        buttonCopy=new Button("Copy");
        pp.add(buttonCopy);

        buttonPaste=new Button("Paste");
        if( (BrowserSettings.Clipboard == null) ||
            !((BrowserSettings.Clipboard[0] instanceof BrPackage)||
              (BrowserSettings.Clipboard[0] instanceof BrClass)||
              (BrowserSettings.Clipboard[0] instanceof BrInterface))  )
            buttonPaste.disable();
        pp.add(buttonPaste);

        buttonCut=new Button("Cut");
        pp.add(buttonCut);

        buttonOpen=new Button("Open in Browser");
        add(buttonOpen);

        buttonReparse=new Button("Reparse");
        add(buttonReparse);

        pp = new Panel();
        pp.setLayout(new VertLayout());
        add(pp);

        buttonCancel=new Button("Cancel");
        pp.add(buttonCancel);

        pack();
        /*resize(insets().left + insets().right +
               preferredSize().width + 10, insets().top +
               insets().bottom + preferredSize().height + 10);*/

        Dimension d = getToolkit().getScreenSize();
        move( (d.width - size().width) / 2 , (d.height - size().height) / 2 );
        show();
        resize(preferredSize());

    }

    public boolean handleEvent(Event event)
    {
        if (event.id == Event.WINDOW_DESTROY) {
            dispose();
            return true;
        }else
        if( event.id == Event.ACTION_EVENT )
        {
            if( event.target == buttonChange )
            {
                dispose();
                // zmenil jsem ho vubec ???
                String s = editName.getText().trim();
                try{
                    if( ComponentManager.getPackage(pkg.getXFile().
                        getPathStr(),s,false) != null )
                    {
                        new modalDialog(BrowserSettings.mainWindow,this,1,
                        "This package already exists. Do you want ",
                        "to move all files to this package?",null,
                        modalDialog.YES_NO);
                        return true;
                    }else
                    {
                    }
                }catch(FileNotFoundException o)
                {
                    new modalDialog(BrowserSettings.mainWindow,this,1,
                    "Do you really want to change package name ( = path )",
                    "and move all files to the new package?",null,
                    modalDialog.YES_NO);
                }
                return true;
            }
            if( event.target == buttonNew )
            {
                dispose();
                createPackage1(pkg,editName.getText().trim());
                return true;
            }
            /*if( event.target == buttonDel )
            {
                dispose();
                new modalDialog(BrowserSettings.mainWindow,this,4,
                    "Do you really want to delete ",
                    "this package and all inside files?",null,
                    modalDialog.YES_NO);
                return true;
            }*/
            if( event.target == buttonCopy )
            {
                dispose();
                return true;
            }
            if( event.target == buttonPaste )
            {
                dispose();
                return true;
            }
            if( event.target == buttonCut )
            {
                dispose();
                return true;
            }
            else
            if( event.target == buttonReparse )
            {
                dispose();
                reparse(pkg);
                return true;
            }
            else
            if( event.target == buttonOpen )
            {
                dispose();
                //BrowserSettings.settings.Mode = 2;
                //BrowserSettings.pomAssoc1 = new BrComponent[1];
                //BrowserSettings.pomAssoc1[0] = pkg;
                BrSettings set = new BrSettings(BrowserSettings.settings);
                    set.Mode = 3;
                BrowserSettings.CreateBrowserWindow(set,ComponentManager.
                    getSelectedPackages());
                return true;
            }else
            if( event.target == buttonCancel )
            {
                dispose();
                return true;
            }
        }
        return super.handleEvent(event);
        /*}catch(FileNotFoundException o)
        {
            new modalDialog(BrowserSettings.mainWindow,null,0,
                    " FileNotFoundException ! ",
                    " I cann't open / find package / file.",null,
                    modalDialog.OK);
        }catch(IOException o)
        {
            new modalDialog(BrowserSettings.mainWindow,null,0,
                    " IOException ! ",
                    " Error during reading file occurred.",null,
                    modalDialog.OK);
        }
        return true;*/
    }

    public void onOk(int index)
    {
        switch( index )
        {
        case 1:
            new modalDialog(BrowserSettings.mainWindow,this,2,
                "Do you want to automatically update ",
                "the package statements in moved files?",null,
                modalDialog.YES_NO);
            break;
        case 2:
            // UPDATE PACKAGE STATEMENTS
            chPackageStatement = true;
            new modalDialog(BrowserSettings.mainWindow,this,3,
                "Do you want to automatically update ",
                "the import statements in all project files?",null,
                modalDialog.YES_NO);
            break;
        case 3:
            chImplementsStatement = true;
            changeName();
            break;
        /*case 4:  //DELETE PACKAGE ZATIM NECHODI!!!!!
            int err = ComponentManager.deletePackage(pkg);
            switch( err )
            {
            case 1:
                new modalDialog(BrowserSettings.mainWindow,null,0,
                    " Some file in delted package ",
                    " cann't be deleted !!! ",null,
                    modalDialog.OK);
                return;
            case 2:
                new modalDialog(BrowserSettings.mainWindow,null,0,
                    " Directory cann't be deleted !!! ",
                    "",null,
                    modalDialog.OK);
                return;
            case 0:
                break;
            default:
                System.out.println("Error PackageView 122" + err);
                return;
            }//switch

            BrowserSettings.repaint(2);
            break;*/
        }
    }
    public void onNo(int index)
    {
        switch( index )
        {
        case 1:
            break;
        case 2:
            chPackageStatement = false;
            chImplementsStatement = false;
            changeName();
            break;
        case 3:
            chImplementsStatement = false;
            changeName();
            break;
        case 4:
            break;
        case 5:
            break;
        }
    }
    public void onCancel(int index)
    {
        switch( index )
        {
        case 1:
            break;
        case 2:
            break;
        case 3:
            break;
        }
    }
    void changeName()
    {
        int err = ComponentManager.movePackage(pkg,new BrPackage(
            new XFile(pkg.getXFile().getFileName(),
            editName.getText().trim(),""),pkg.getProject()),
            chPackageStatement,chImplementsStatement);

        if( err != 0 )
            new modalDialog(BrowserSettings.mainWindow,this,4,
                    "Error ",
                    null,null,
                    modalDialog.OK);

        BrowserSettings.repaint(2);
        return;
    }
    public static void createPackage(BrPackage pkg,String str)
    {
        String s = pkg.getXFile().getPackage();
        createPackage1(pkg,s.equals ("") ? str : (s + '.' + str));
        return;
    }
    private static void createPackage1(BrPackage pkg,String s)
    {
        XFile xf = new XFile(pkg.getXFile().getPathStr(),s,"");
        BrPackage p = new BrPackage(xf,pkg.getProject());
        switch( ComponentManager.addPackage(p) )
        {
        case 2:
            new modalDialog(BrowserSettings.mainWindow,null,0,
                "This package already exists ! ",
                null,null,
                modalDialog.OK);
            return;
        case 3:
            new modalDialog(BrowserSettings.mainWindow,null,0,
                " I cann't create directory : ",
                xf.getFileName(),null,
                modalDialog.OK);
            return;
        case 1:
            System.out.println("Error PackageView 23");
            return;
        }//case
        BrowserSettings.repaint(2);
        return;
    }
    public static void reparse(BrPackage pkg)
    {
        try{
            ComponentManager.reparsePackage(pkg);
        }catch(FileNotFoundException o)
        {
            new modalDialog(BrowserSettings.mainWindow,null,4,
                    " FileNotFoundException ! ",
                    " I cann't open / find package / file.",null,
                    modalDialog.OK);
        }catch(IOException o)
        {
            new modalDialog(BrowserSettings.mainWindow,null,4,
                    " IOException ! ",
                    " Error during reading file occurred.",null,
                    modalDialog.OK);
        }
        BrowserSettings.repaint(2);
    }

}










