/**
 * ThreadsView
 *
 * @author Roman Blazevic
 * @version 970208
 */

package xelfi.debugger;

import java.awt.*;
import xelfi.top.TopDialog;
import xelfi.top.TopLevel;

/*
 * This is a view on the data given by the Debugger.
 * It is a view on thread groups and threads in the debugged application.
 */

public class ThreadsView extends TopDialog
{
	private Debugger document;
	private List list;

	static final int KEY_ENTER = 10;

	static final int HINT_COMPLETE_UPDATE = 0;

	/**
	 * ThreadsView constructor.
	 *
	 * debugger - the document for this view
	 */
	ThreadsView(Debugger debugger)
	{
		super(TopLevel.getMenu(), false);
		setTitle("Threads");
		//super("Threads");
 		setBackground(Color.lightGray);

		document = debugger;
		list = new List();
		add("Center", list);
	}

	/**
	 * My handleEvent() implementation.
	 */
	public boolean handleEvent(Event event)
	{
		if (event.id == Event.KEY_PRESS && event.key == 18) // Ctrl+R - refresh
		{
			update(HINT_COMPLETE_UPDATE, -1);
			return true;
		}

		if (!(event.id == Event.KEY_PRESS && event.key == KEY_ENTER)
			&& !(event.id == Event.ACTION_EVENT))
			return super.handleEvent(event);

		int selectedIndex = list.getSelectedIndex();

		if (selectedIndex == -1)
			return true;

	/*        RemoteThreadGroup[] rtg = document.getThreadGroups();

		if (rtg == null)
		{
			Output output = TopLevel.getOutput();

			update(HINT_COMPLETE_UPDATE, -1);
			output.show();
			output.println("\"Threads\" window was out of date and updated");
			return true;
		}

		RemoteThreadGroup ctg = null;
		RemoteThread ct = null;
		int lineIndex = 0;
		int threadGroupIndex = 1;

		for(int i = 0; i < rtg.length; i++)
			try
			{
				// without "system" thread groups (system and main groups)
				if (rtg[i].getName().compareTo("system") == 0 ||
					rtg[i].getName().compareTo("main") == 0)
					continue;

				String string = " ["+(threadGroupIndex)+"] "+rtg[i].getName();

				if (!list.getItem(lineIndex).equals(string))
				{
					Output output = TopLevel.getOutput();

					update(HINT_COMPLETE_UPDATE, -1);
					output.show();
					output.println("\"Threads\" window was out of date and updated");
					return true;
				}
				else
					if (lineIndex == selectedIndex)
						return true;

				RemoteThread rt[] = rtg[i].listThreads(true);

				threadGroupIndex++;
				lineIndex++;

				for(int j = 0; j < rt.length; j++)
				{
					string = "      "+rt[j].getName()+" : "+rt[j].getStatus();

					if (lineIndex == selectedIndex && list.getItem(lineIndex).equals(string))
					{
						ct = rt[j];
						break;
					}

					lineIndex++;
				}

				if (ct != null) // it was finally found
				{
					ctg = rtg[i];
					break;
				}
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}

			if (ct == null)
			{
				Output output = TopLevel.getOutput();

				update(HINT_COMPLETE_UPDATE, -1);
				output.show();
				output.println("\"Threads\" window was out of date and updated");
				return true;
			}

			try
			{
				if (ct.getStatus().equals("at breakpoint")
					//|| ct.getStatus().equals("suspended")
					)
					document.threadChosen(ctg, ct);
				else
				{
					Output output = TopLevel.getOutput();

					output.show();
					output.println("thread is not at breakpoint");
					//output.println("thread is not suspended or at breakpoint");
					return true;
				}
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}*/

		return true;
	}

	/**
	 * This method is called when the content of the view must be
	 * updated.
	 */
	void update(int hint, int index)
	{
		if (!isVisible())
			return;

		if (hint != HINT_COMPLETE_UPDATE)
		{
			System.out.println("unsupported hint");
			return;
		}

        return;
		
	}

	/**
	 * My show() implementation.
	 */
	public void show()
	{
		super.show();
	}
}
