/**
 * Watch
 *
 * @author Roman Blazevic
 * @version 970208
 */

package xelfi.debugger;

/**
 * This is a class which is stored in the document class Watches.
 * It contains name and a current value of the watched variable.
 */

class Watch
{
	private String name;
	private String currentValue; // a value given by the Debugger

	/**
	 * Watch constructor.
	 */
	Watch(String name, String currentValue)
	{
		this.name = name;
		this.currentValue = currentValue;
	}

	/**
	 * Watch constructor.
	 */
	Watch(String name)
	{
		this.name = name;
		currentValue = "";
	}

	/**
	 * Returns a name of the watch.
	 */
	String getName()
	{
		return name;
	}

	/**
	 * Returns the current value of the watch.
	 */
	String getCurrentValue()
	{
		return currentValue;
	}

	/**
	 * Sets the current value of the watch (given from the Debugger).
	 */
	void setCurrentValue(String currentValue)
	{
		this.currentValue = currentValue;
	}

	/**
	 * Returns the string description of the watch in tbe form:
	 *   name: currentValue
	 */
	public String toString()
	{
		return name+": "+currentValue;
	}
}
