/**
* Xelfi
*/

package xelfi.design.components.dialogs;

import java.awt.*;

/**
 * @version 	1.00, 07 Dec 1996
 * @author 	Petr Hamernik
 */


public class XFMessageBox extends Dialog {
    Button OKBut;
    Label label;

    public XFMessageBox(Frame aParent, String aTitle, String aLabel) {
	    super(aParent, aTitle, true);

        setLayout(null);
        addNotify();
        resize(insets().left + insets().right + 320, insets().top + insets().bottom + 80);
        label=new Label(aLabel, Label.CENTER);
        add(label);
        label.reshape(insets().left + 10,insets().top + 10,300,24);
        OKBut=new Button("OK");
        add(OKBut);
        OKBut.reshape(insets().left + 120,insets().top + 45,60,24);
    	setResizable(false);
    }

    public synchronized void show() {
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Dimension screenSize = toolkit.getScreenSize();
		Dimension dialogSize = size();
		move((screenSize.width-dialogSize.width)/2,(screenSize.height-dialogSize.height)/2);
		super.show();
    }

    public synchronized void wakeUp() {
    	notify();
    }

    public boolean handleEvent(Event event) {
		if (event.target == OKBut) {
			hide();
			dispose();
			return true;
		}
		else
    	if (event.id == Event.WINDOW_DESTROY) {
    	    hide();
	    dispose();
    	    return true;
    	}
    	return super.handleEvent(event);
    }

}
