/**
* Xelfi
*/

package xelfi.design.components.xawt;

/**
  *
  * @version 	2.12, 03 Apr 1997
  * @author 	Petr Hamernik
  *
  */

import java.awt.*;
import java.io.*;
import xelfi.awt.Bevel;
import xelfi.design.components.*;
import xelfi.design.components.property.*;
import xelfi.design.forms.XelfiDesignForm;
import xelfi.design.util.XFDesignConstants;
import xelfi.design.util.XFDesignOptions;
import xelfi.design.util.XFDesignUtils;

public class XBevel extends XAWTPanel {
	private Bevel bevel;

	private static int propertyCount = 9;
	private Object propDef[];
	private boolean propDefSet = false;
	private static int eventCount = 3;
	private String events[] = new String[eventCount];
	protected static Image icon = null;
	
	public XBevel() { 
		super(XAWTPanel.WITHOUT_DRAGBORDER);
		setComponent(bevel = new Bevel());
		propDef = new Object[propertyCount];
		for (int i=0; i<propertyCount; i++)
			propDef[i] = null;
		if (icon == null)
			icon = loadIcon("bevel.gif");
	}

	public int setDesignSize(int w, int h) { 
		Dimension d = bevel.size();
		if (d == null)
			d = new Dimension(w,h);
		else {
			if (bevel.getDirection() == bevel.DIR_HORIZONTAL) {
				if (w != 0)
					d.width = w;
			}
			else {
				if (h != 0)
					d.height = h;
			}
		}
		bevel.resize(d);
		size = bevel.size();
		d = new Dimension(bevel.size());
		if (sel != XFDesignConstants.SEL_UNSELECT) {
			d.height += 2*XFDesignOptions.selectionSize;
			d.width += 2*XFDesignOptions.selectionSize;
		}
		resize(d);
		regenForm(XFDesignConstants.GEN_RESHAPE);
		return XFDesignConstants.RSP_OK;
	}

	protected void regenForm(int what) {
		if (parentForm != null)
			parentForm.regenerateCode(this, what);
	}

	public String[] neededImports() {
		String[] ret = new String[1];
		ret[0] = "xelfi.awt.Bevel";
		return ret;
	}

	public Image getIcon() {
		return icon; 
	}

	private boolean propertyDefault(int i) throws XFPropertyIndexOutOfBoundsException {
		if (propDefSet)
			propertiesSetDefault();
		if (propDef[i] == null)
			return false;
		switch (i) {
			case 0: return (((Boolean) propDef[i]).booleanValue() == bevel.getStyle());
			case 1: return (((Boolean) propDef[i]).booleanValue() == bevel.getDirection());
			case 2: return (((Boolean) propDef[i]).booleanValue() == bevel.isEnabled());
			case 3: return (((Boolean) propDef[i]).booleanValue() == bVisible);
			case 4: return ((Color) propDef[i]).equals(bevel.getBackground());
			case 5: return (((Boolean) propDef[i]).booleanValue() == parentColor);
			case 6: return (bevel.defaultBorderColor.equals(bevel.getBorderColor()));
			case 7: return (bevel.defaultBorderWidth == bevel.getBorderWidth());
			case 8: return (bevel.defaultBevelWidth == bevel.getBevelWidth());
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	private void propertiesSetDefault() {
		if (propDefSet)
			return;
		propDefSet = true;

		propDef[0] = new Boolean(bevel.defaultStyle);
		propDef[1] = new Boolean(bevel.defaultDirection);
		propDef[2] = new Boolean(bevel.isEnabled());
		propDef[3] = new Boolean(bVisible);
		if (getBackground() != null)
				propDef[4] = new Color(bevel.getBackground().getRGB());
		propDef[5] = new Boolean(parentColor);
		propDef[6] = bevel.defaultBorderColor;
		propDef[7] = new Integer(bevel.defaultBorderWidth);
		propDef[8] = new Integer(bevel.defaultBevelWidth);
	}

	public int getPropertyCount() { return propertyCount; }
	
	public Object getProperty(int index) throws XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: return new Boolean(bevel.getStyle());
			case 1: return new Boolean(bevel.getDirection());
			case 2: return (bevel.isEnabled()) ? Boolean.TRUE : Boolean.FALSE;
			case 3: return (bVisible) ? Boolean.TRUE : Boolean.FALSE;
			case 4: return bevel.getBackground();
			case 5: return (parentColor) ? Boolean.TRUE : Boolean.FALSE;
			case 6: return bevel.getBorderColor();
			case 7: return new Integer(bevel.getBorderWidth());
			case 8: return new Integer(bevel.getBevelWidth());
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}
			
	public String[] getPropertyNames() { 
		String list[] = new String[propertyCount];
		list[0] = "Style";
		list[1] = "Direction";
		list[2] = "Enabled";
		list[3] = "Visible";
		list[4] = "Bevel Color";
		list[5] = "Parent Color";
		list[6] = "Border Color";
		list[7] = "Border Width";
		list[8] = "Bevel Width";
		return list;
	}
		
	public String getPropertyString(int index) throws 
		XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 2:
			case 3: return XBooleanPropertyType.viewString(getProperty(index));
			case 4: return XColorPropertyType.viewString(getProperty(index));
			case 5: return XBooleanPropertyType.viewString(getProperty(index));
			case 6: return XColorPropertyType.viewString(getProperty(index));
			case 7:
			case 8: return XIntegerPropertyType.viewString(getProperty(index));
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int getPropertyViewerType(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: 
			case 1: return XFDesignConstants.PVT_CHOICE_STRICT;
			case 2:
			case 3: return XFDesignConstants.PVT_CHECK;
			case 4: return XFDesignConstants.PVT_SPECIAL;
			case 5: return XFDesignConstants.PVT_CHECK;
			case 6: return XFDesignConstants.PVT_SPECIAL;
			case 7: return XFDesignConstants.PVT_INPUT_INT;
			case 8: return XFDesignConstants.PVT_INPUT_INT;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public String[] getPropertyValueNames(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: String[] ret = new String[2];
					ret[0] = "RAISED";
					ret[1] = "LOWERED";
					return ret;
			case 1: String[] ret2 = new String[2];
					ret2[0] = "HORIZONTAL";
					ret2[1] = "VERTICAL";
					return ret2;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public Object[] getPropertyValueValues(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: Boolean[] ret = new Boolean[2];
					ret[0] = new Boolean(bevel.ST_RAISED);
					ret[1] = new Boolean(bevel.ST_LOWERED);
					return ret;
			case 1: Boolean[] ret2 = new Boolean[2];
					ret2[0] = new Boolean(bevel.DIR_HORIZONTAL);
					ret2[1] = new Boolean(bevel.DIR_VERTICAL);
					return ret2;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int setProperty(int index, Object value) throws 	
		XFPropertyIndexOutOfBoundsException,
		XFPropertyBadValueTypeException 
	{ 
		int ret = XFDesignConstants.RSP_OK;
		int regen = XFDesignConstants.GEN_SETPROPS;
		if (!propDefSet)
			propertiesSetDefault();
		switch (index) { 
			case 0: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					bevel.setStyle(((Boolean)value).booleanValue());
				 	ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 1: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					bevel.setDirection(((Boolean)value).booleanValue());
				 	ret = ret | XFDesignConstants.RSP_OTHER_PROP | XFDesignConstants.RSP_REPAINT_COMP;
					setDesignSize(0,0);
					break;
			case 2:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					bevel.enable(((Boolean)value).booleanValue());
					break;
			case 3: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					bVisible = ((Boolean)value).booleanValue();
					break;
			case 4: if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					bevel.setBackground((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (parentColor) {
						parentColor = false;
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					bevel.repaint();
					break;
			case 5:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setParentColor(((Boolean)value).booleanValue());
					if (parentColor)
						ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 6:if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					bevel.setBorderColor((Color)value);
				 	ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					setDesignSize(0,0);
					break;
			case 7:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					bevel.setBorderWidth(((Integer)value).intValue());
				 	ret = ret | XFDesignConstants.RSP_OTHER_PROP | XFDesignConstants.RSP_REPAINT_COMP;
					setDesignSize(0,0);
					break;
			case 8:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					bevel.setBevelWidth(((Integer)value).intValue());
				 	ret = ret | XFDesignConstants.RSP_OTHER_PROP | XFDesignConstants.RSP_REPAINT_COMP;
					setDesignSize(0,0);
					break;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
		regenForm(regen);
		
		return ret;
	}
			
	public void specialPropertyInput(Frame parent, int index) throws 	
		XFPropertyIndexOutOfBoundsException, 
		XFPropertyNoSpecialInputException { 
		if ((index < 0) || (index >= propertyCount)) throw new XFPropertyIndexOutOfBoundsException();
		switch (index) { 
			case 4:
			case 6: XColorPropertyType.invokeSpecialInput(parent, this, index);
					break;
			default: throw new XFPropertyNoSpecialInputException();
		}
	}

	public int getEventCount() {
		return eventCount;
	}

	public String[] getEventNames() {
		String list[] = new String[eventCount];
		list[0] = "OnGotFocus";
		list[1] = "OnLostFocus";
		return list;
	}

	public String getEvent(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount)) {
			if (events[index] == null)
				return null;
			else
				return new String(events[index]); 
		}
		else throw new XFPropertyIndexOutOfBoundsException();
	}		
		
	public void setEvent(int index, String value) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount))
			events[index] = value;
		else throw new XFPropertyIndexOutOfBoundsException();
	}		

	public String getClassName() {
		return "Bevel";
	}
	
	public String generateCode(int what) {
		String gen = "";
		switch (what) {
			case XFDesignConstants.GEN_VARIABLE: 
				gen = getClassName()+" "+ name + ";\n";
				break;
			case XFDesignConstants.GEN_INIT: 
				gen = name + " = new " + getClassName() + "();\n";
				break;
			case XFDesignConstants.GEN_SETPROPS:
				if (!propDefSet)
					propertiesSetDefault();
				for (int i = 0; i < propertyCount; i++) {
					if (!propertyDefault(i)) {
						switch(i) {
							case 0: gen = gen + name + ".setStyle(Bevel." + 
										((bevel.getStyle() == Bevel.ST_RAISED) ? "ST_RAISED" : "ST_LOWERED") +
										");\n";
									break;
							case 1: gen = gen + name + ".setDirection(Bevel." + 
										((bevel.getDirection() == Bevel.DIR_HORIZONTAL) ? 
										"DIR_HORIZONTAL" : "DIR_VERTICAL") + ");\n";
									break;
							case 2: gen = gen + name + (bevel.isEnabled() ? ".enable();\n" : ".disable();\n");
									break;
							case 3: gen = gen + name + ((bVisible) ? ".show();\n" : ".hide();\n");
									break;
							case 4: if (!parentColor)
										gen = gen + name + ".setBackground(" +
											XFDesignUtils.genColor(bevel.getBackground()) + ");\n";
									break;
							case 6: gen = gen + name + ".setBorderColor(" +
										XFDesignUtils.genColor(bevel.getBorderColor()) + ");\n";
									break;
							case 7: gen = gen + name + ".setBorderWidth(" + bevel.getBorderWidth() + ");\n";
									break;
							case 8: gen = gen + name + ".setBevelWidth(" + bevel.getBevelWidth() + ");\n";
									break;
						}
					}
				}
				break;			
			case XFDesignConstants.GEN_RESHAPE:
				if (((XelfiVisualContainer) getParent()).getDesignLayout().allowsDragging()) {
					if (!autoSize) 
						if (getParent() instanceof XelfiDesignForm)
							gen = name + ".reshape(insets.left+"+position.x+", insets.top+"+position.y+","+size.width+","+size.height+");\n";
						else 
							gen = name + ".reshape("+position.x+","+position.y+","+size.width+","+size.height+");\n";
					else {
						gen = name + ".resize(" + name + ".preferredSize());\n";
						if (getParent() instanceof XelfiDesignForm)
							gen = gen + name + ".move(insets.left+"+position.x+", insets.top+"+position.y+");\n";
						else
							gen = gen + name + ".move("+position.x+","+position.y+");\n";
					}
				}
				break;
		}
		return gen;
	}

	public String generateEventCondition(int index) throws XFPropertyIndexOutOfBoundsException {
		String evt = XFDesignOptions.eventVarName;
		switch (index) { 
			case 0: return evt +".id == Event.GOT_FOCUS && "+evt+".target == "+getName();
			case 1: return evt +".id == Event.LOST_FOCUS && "+evt+".target == "+getName();
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public boolean handleEvent(Event evt) {
		evt.target = this;
		return super.handleEvent(evt);
	}

	public void loadFromStream(DataInput stream) throws IOException {

		super.loadFromStream(stream);

		if (!propDefSet)
			propertiesSetDefault();

		for (int i = 0; i < propertyCount; i++) {
			if (stream.readBoolean())
				propDef[i] = null;
			else switch (i) {
				case 0: bevel.setStyle(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 1: bevel.setDirection(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 2: bevel.enable(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 3: bVisible = XBooleanPropertyType.loadBFromStream(stream); break;
				case 4: bevel.setBackground(XColorPropertyType.loadFromStream(stream)); break;
				case 5: setParentColor(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 6: bevel.setBorderColor(XColorPropertyType.loadFromStream(stream)); break;
				case 7: bevel.setBorderWidth(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 8: bevel.setBorderWidth(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if (stream.readBoolean())
				parentForm.assignEvent(this, i, stream.readUTF());
		}
	}		

	public void saveToStream(DataOutput stream) throws IOException {

		super.saveToStream(stream);

		for (int i = 0; i < propertyCount; i++) {
			boolean b = propertyDefault(i);
			stream.writeBoolean(b);
			if (!b) {
				switch (i) {
					case 0: XBooleanPropertyType.saveToStream(bevel.getStyle(), stream); break;
					case 1: XBooleanPropertyType.saveToStream(bevel.getDirection(), stream); break;
					case 2: XBooleanPropertyType.saveToStream(bevel.isEnabled(), stream); break;
					case 3: XBooleanPropertyType.saveToStream(bVisible, stream); break;
					case 4: XColorPropertyType.saveToStream(bevel.getBackground(), stream); break;
					case 5: XBooleanPropertyType.saveToStream(parentColor, stream); break;
					case 6: XColorPropertyType.saveToStream(bevel.getBorderColor(), stream); break;
					case 7: XIntegerPropertyType.saveToStream(new Integer(bevel.getBorderWidth()), stream); break;
					case 8: XIntegerPropertyType.saveToStream(new Integer(bevel.getBorderWidth()), stream); break;
				}
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if ((events[i] != null) && (events[i].length() > 0)) {
				stream.writeBoolean(true);
				stream.writeUTF(events[i]);
			}
			else stream.writeBoolean(false);
		}
	}
}