/**
* Xelfi
*/

package xelfi.design.components.xawt;

/**
  *
  * @version 	2.12, 03 Apr 1997
  * @author 	Petr Hamernik, Ian Formanek
  *
  */

import java.awt.*;
import java.io.*;
import xelfi.design.components.*;
import xelfi.design.components.property.*;
import xelfi.design.forms.XelfiDesignForm;
import xelfi.design.util.XFDesignConstants;
import xelfi.design.util.XFDesignOptions;
import xelfi.design.util.XFDesignUtils;

public class XChoice extends XAWTPanel {
	private Choice choice;
	private static int propertyCount = 10;
	private Object propDef[];
	private boolean propDefSet = false;
	private static int eventCount = 3;
	private String events[] = new String[eventCount];
	protected static Image icon = null;

	public XChoice() { 
		super(XAWTPanel.WITH_DRAGBORDER);
		setComponent(choice = new Choice());
		propDef = new Object[propertyCount];
		for (int i=0; i<propertyCount; i++)
			propDef[i] = null;
		if (icon == null)
			icon = loadIcon("choice.gif");
	}
	protected void regenForm(int what) {
		if (parentForm != null)
			parentForm.regenerateCode(this, what);
	}

	public String[] neededImports() {
		String[] ret = new String[1];
		ret[0] = "java.awt.Choice";
		return ret;
	}

	public Image getIcon() {
		return icon; 
	}

	private boolean propertyDefault(int i) throws XFPropertyIndexOutOfBoundsException {
		if (propDefSet)
			propertiesSetDefault();
		if (propDef[i] == null)
			return false;
		switch (i) {
			case 0: return ((Color) propDef[i]).equals(choice.getBackground());
			case 1: return ((Color) propDef[i]).equals(choice.getForeground());
			case 2: return (((Boolean) propDef[i]).booleanValue() == choice.isEnabled());
			case 3: return (((Boolean) propDef[i]).booleanValue() == bVisible);
			case 4: return ((Font) propDef[i]).equals(choice.getFont());
			case 5: return (((Boolean) propDef[i]).booleanValue() == autoSize);
			case 6: return (((Boolean) propDef[i]).booleanValue() == parentColor);
			case 7: return (((Boolean) propDef[i]).booleanValue() == parentFont);
			case 8: return false;
			case 9: return (((Integer) propDef[i]).intValue() == choice.getSelectedIndex());
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	private void propertiesSetDefault() {
		if (propDefSet)
			return;
		propDefSet = true;
		if (choice.getBackground() != null)
				propDef[0] = new Color(choice.getBackground().getRGB());
		if (choice.getForeground() != null)
				propDef[1] = new Color(choice.getForeground().getRGB());
		propDef[2] = new Boolean(choice.isEnabled());
		propDef[3] = new Boolean(bVisible);
		if (choice.getFont() != null)
			propDef[4] = new Font(choice.getFont().getName(),choice.getFont().getStyle(),choice.getFont().getSize());
		propDef[5] = new Boolean(autoSize);
		propDef[6] = new Boolean(parentColor);
		propDef[7] = new Boolean(parentFont);
		propDef[8] = new String[1];
		propDef[9] = new Integer(choice.getSelectedIndex());
	}

	public int getPropertyCount() { return propertyCount; }
	
	public Object getProperty(int index) throws XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: return choice.getBackground();
			case 1: return choice.getForeground();
			case 2: return (choice.isEnabled()) ? Boolean.TRUE : Boolean.FALSE;
			case 3: return (bVisible) ? Boolean.TRUE : Boolean.FALSE;
			case 4: return choice.getFont();
			case 5: return (autoSize) ? Boolean.TRUE : Boolean.FALSE;
			case 6: return (parentColor) ? Boolean.TRUE : Boolean.FALSE;
			case 7: return (parentFont) ? Boolean.TRUE : Boolean.FALSE;
			case 8: String[] ret = new String[choice.countItems()];
					for (int i = 0; i < choice.countItems(); i++)
						ret[i] = choice.getItem(i);
					return ret;
			case 9: return new Integer(choice.getSelectedIndex());
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}
			
	public String[] getPropertyNames() { 
		String list[] = new String[propertyCount];
		list[0] = "Background Color";
		list[1] = "Foreground Color";
		list[2] = "Enabled";
		list[3] = "Visible";
		list[4] = "Font";
		list[5] = "Auto Size";
		list[6] = "Parent Color";
		list[7] = "Parent Font";
		list[8] = "Initial Values";
		list[9] = "Selected";
		
		return list;
	}
		
	public String getPropertyString(int index) throws 
		XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: 
			case 1: return XColorPropertyType.viewString(getProperty(index));
			case 2:
			case 3: return XBooleanPropertyType.viewString(getProperty(index));
			case 4: return XFontPropertyType.viewString(getProperty(index));
			case 5: 
			case 6: 
			case 7: return XBooleanPropertyType.viewString(getProperty(index));
			case 8: return XStringArrayPropertyType.viewString(getProperty(index));
			case 9: return XIntegerPropertyType.viewString(getProperty(index));
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int getPropertyViewerType(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: 
			case 1: return XFDesignConstants.PVT_SPECIAL;
			case 2:
			case 3: return XFDesignConstants.PVT_CHECK;
			case 4: return XFDesignConstants.PVT_SPECIAL;
			case 5: 
			case 6: 
			case 7: return XFDesignConstants.PVT_CHECK;
			case 8: return XFDesignConstants.PVT_SPECIAL;
			case 9: return XFDesignConstants.PVT_INPUT_INT;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public String[] getPropertyValueNames(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public Object[] getPropertyValueValues(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int setProperty(int index, Object value) throws 	
		XFPropertyIndexOutOfBoundsException,
		XFPropertyBadValueTypeException 
	{ 
		int ret = XFDesignConstants.RSP_OK;
		int regen = XFDesignConstants.GEN_SETPROPS;
		if (!propDefSet)
			propertiesSetDefault();
		switch (index) { 
			case 0: if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					choice.setBackground((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					choice.hide();
					choice.show();
					if (parentColor) {
						parentColor = false;
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					break;
			case 1:	if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					choice.setForeground((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					choice.hide();
					choice.show();
					if (parentColor) {
						parentColor = false;
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					break;
			case 2:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					choice.enable(((Boolean)value).booleanValue());
					break;
			case 3: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					bVisible = ((Boolean)value).booleanValue();
					break;
			case 4: if (!(value instanceof Font)) throw new XFPropertyBadValueTypeException();
					choice.setFont((Font)value); 
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP | XFDesignConstants.RSP_OTHER_PROP;
					if (parentFont) {
						parentFont = false;
						if (autoSize) {
							setDesignSize(0,0);
							regen = regen | XFDesignConstants.GEN_RESHAPE;
						}
					}
					repaintComponent();
					break;
			case 5:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setAutoSize(((Boolean)value).booleanValue());
					if (autoSize) {
						repaintComponent();
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					regen = regen | XFDesignConstants.GEN_RESHAPE;
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 6:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setParentColor(((Boolean)value).booleanValue());
					if (parentColor)
						ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 7: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setParentFont(((Boolean)value).booleanValue());
					if (parentFont)
						ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (autoSize)
					 	ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					break;
			case 8: if (!(value instanceof String[])) throw new XFPropertyBadValueTypeException();
					if (choice.countItems() != 0) {
						Color fg = choice.getForeground();
						Color bg = choice.getBackground();
						Point p = choice.location();
						Dimension d = choice.size();
						Font fnt = choice.getFont();
						boolean en = choice.isEnabled();

						remove(choice);
						choice = new Choice();
						add(choice);
						component = choice;

						choice.setForeground(fg);
						choice.setBackground(bg);
						choice.move(p.x, p.y);
						choice.resize(d);
						choice.setFont(fnt);
						choice.enable(en);
						choice.hide();
						choice.show();
					}
					for (int i = 0; i < ((String [])value).length; i++)
						choice.addItem(((String [])value)[i]);
					repaintComponent();
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					break;
			case 9: if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					try {
						choice.select(((Integer)value).intValue());
					}
					catch (IllegalArgumentException e) {
						System.out.println("Illegal Argument Exception");					
					}	
					break;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
		regenForm(regen);
		
		return ret;
	}

	public void specialPropertyInput(Frame parent, int index) throws 	
		XFPropertyIndexOutOfBoundsException, 
		XFPropertyNoSpecialInputException { 
		if ((index < 0) || (index >= propertyCount)) throw new XFPropertyIndexOutOfBoundsException();
		switch (index) { 
			case 0:
			case 1: XColorPropertyType.invokeSpecialInput(parent, this, index);
						break;
			case 4: XFontPropertyType.invokeSpecialInput(parent, this, index);
						break;
			case 8: XStringArrayPropertyType.invokeSpecialInput(parent, this, index);
						break;
			default: throw new XFPropertyNoSpecialInputException();
		}
	}

	public int getEventCount() {
		return eventCount;
	}

	public String[] getEventNames() {
		String list[] = new String[eventCount];
		list[0] = "OnSelect";
		list[1] = "OnGotFocus";
		list[2] = "OnLostFocus";
		return list;
	}

	public String getEvent(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount)) {
			if (events[index] == null)
				return null;
			else
				return new String(events[index]); 
		}
		else throw new XFPropertyIndexOutOfBoundsException();
	}		
		
	public void setEvent(int index, String value) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount))
			events[index] = value;
		else throw new XFPropertyIndexOutOfBoundsException();
	}		

	public String getClassName() {
		return "Choice";
	}
	
	public String generateCode(int what) {
		String gen = "";
		switch (what) {
			case XFDesignConstants.GEN_VARIABLE: 
				gen = getClassName()+" "+ name + ";\n";
				break;
			case XFDesignConstants.GEN_INIT: 
				gen = name + " = new " + getClassName() + "();\n";
				break;
			case XFDesignConstants.GEN_SETPROPS:
				if (!propDefSet)
					propertiesSetDefault();
				for (int i = 0; i < propertyCount; i++) {
					if (!propertyDefault(i)) {
						switch(i) {
							case 0: if (!parentColor)
										gen = gen + name + ".setBackground(" +
											XFDesignUtils.genColor(choice.getBackground()) + ");\n";
									break;
							case 1: if (!parentColor)
										gen = gen + name + ".setForeground(" +
											XFDesignUtils.genColor(choice.getForeground()) + ");\n";
									break;
							case 2: gen = gen + name + (choice.isEnabled() ? ".enable();\n" : ".disable();\n");
									break;
							case 3: gen = gen + name + ((bVisible) ? ".show();\n" : ".hide();\n");
									break;
							case 4: if (!parentFont) {
										gen = gen + name + ".setFont(" + 
											XFDesignUtils.genFont(choice.getFont())+");\n";
									}
									break;
							case 8: for (int j = 0; j < choice.countItems(); j++)
										gen = gen + name + ".addItem(\"" + choice.getItem(j) + "\");\n";
									break;
							case 9: gen = gen + name + ".select(" + choice.getSelectedIndex() + ");\n";
						}
					}
				}
				break;			
			case XFDesignConstants.GEN_RESHAPE:
				if (((XelfiVisualContainer) getParent()).getDesignLayout().allowsDragging()) {
					if (!autoSize) 
						if (getParent() instanceof XelfiDesignForm)
							gen = name + ".reshape(insets.left+"+position.x+", insets.top+"+position.y+","+size.width+","+size.height+");\n";
						else 
							gen = name + ".reshape("+position.x+","+position.y+","+size.width+","+size.height+");\n";
					else {
						gen = name + ".resize(" + name + ".preferredSize());\n";
						if (getParent() instanceof XelfiDesignForm)
							gen = gen + name + ".move(insets.left+"+position.x+", insets.top+"+position.y+");\n";
						else
							gen = gen + name + ".move("+position.x+","+position.y+");\n";
					}
				}
				break;
		}
		return gen;
	}

	public String generateEventCondition(int index) throws XFPropertyIndexOutOfBoundsException {
		String evt = XFDesignOptions.eventVarName;
		switch (index) { 
			case 0: return evt +".id == Event.ACTION_EVENT && "+evt+".target == "+getName();
			case 1: return evt +".id == Event.GOT_FOCUS && "+evt+".target == "+getName();
			case 2: return evt +".id == Event.LOST_FOCUS && "+evt+".target == "+getName();
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public void loadFromStream(DataInput stream) throws IOException {

		super.loadFromStream(stream);

		if (!propDefSet)
			propertiesSetDefault();

		for (int i = 0; i < propertyCount; i++) {
			if (stream.readBoolean()) {
				propDef[i] = null;
			}
			else switch (i) {
				case 0: choice.setBackground(XColorPropertyType.loadFromStream(stream)); break;
				case 1: choice.setForeground(XColorPropertyType.loadFromStream(stream)); break;
				case 2: choice.enable(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 3: bVisible = XBooleanPropertyType.loadBFromStream(stream); break;
				case 4: choice.setFont(XFontPropertyType.loadFromStream(stream)); break;
				case 5: setAutoSize(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 6: setParentColor(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 7: setParentFont(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 8: String[] str = (XStringArrayPropertyType.loadFromStream(stream));
						for (int j = 0; j < str.length; j++) 
							choice.addItem(str[j]);
						break;
				case 9: choice.select(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if (stream.readBoolean())
				parentForm.assignEvent(this, i, stream.readUTF());
		}
	}		
	
	public void saveToStream(DataOutput stream) throws IOException {

		super.saveToStream(stream);

		for (int i = 0; i < propertyCount; i++) {
			boolean b = propertyDefault(i);
			stream.writeBoolean(b);
			if (!b) {
				switch (i) {
					case 0: XColorPropertyType.saveToStream(choice.getBackground(), stream); break;
					case 1: XColorPropertyType.saveToStream(choice.getForeground(), stream); break;
					case 2: XBooleanPropertyType.saveToStream(choice.isEnabled(), stream); break;
					case 3: XBooleanPropertyType.saveToStream(bVisible, stream); break;
					case 4: XFontPropertyType.saveToStream(choice.getFont(), stream); break;
					case 5: XBooleanPropertyType.saveToStream(autoSize, stream); break;
					case 6: XBooleanPropertyType.saveToStream(parentColor, stream); break;
					case 7: XBooleanPropertyType.saveToStream(parentFont, stream); break;
					case 8: String[] str = new String[choice.countItems()];
							for (int j = 0; j < choice.countItems(); j++)
								str[j] = choice.getItem(j);
							XStringArrayPropertyType.saveToStream(str, stream); break;
					case 9: XIntegerPropertyType.saveToStream(new Integer(choice.getSelectedIndex()), stream); break;
				}
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if ((events[i] != null) && (events[i].length() > 0)) {
				stream.writeBoolean(true);
				stream.writeUTF(events[i]);
			}
			else stream.writeBoolean(false);
		}
	}
	
}