/**
* Xelfi
*/

package xelfi.design.components.xawt;

/**
  *
  * @version 	2.12, 03 Apr 1997
  * @author 	Petr Hamernik, Ian Formanek
  *
  */

import java.awt.*;
import java.io.*;
import xelfi.design.components.*;
import xelfi.design.components.property.*;
import xelfi.design.forms.XelfiDesignForm;
import xelfi.design.util.XFDesignConstants;
import xelfi.design.util.XFDesignOptions;
import xelfi.design.util.XFDesignUtils;

public class XTextArea extends XAWTPanel {
	private TextArea text;
	private static int propertyCount = 12;
	private Object propDef[];
	private boolean propDefSet = false;
	private static int eventCount = 6;
	private String events[] = new String[eventCount];
	protected static Image icon = null;

	public XTextArea() { 
		super(XAWTPanel.WITH_DRAGBORDER);
		setComponent(text = new TextArea());
		propDef = new Object[propertyCount];
		for (int i=0; i<propertyCount; i++)
			propDef[i] = null;
		if (icon == null)
			icon = loadIcon("textarea.gif");
	}

	protected void regenForm(int what) {
		if (parentForm != null)
			parentForm.regenerateCode(this, what);
	}

	public String[] neededImports() {
		String[] ret = new String[1];
		ret[0] = "java.awt.TextArea";
		return ret;
	}

	public Image getIcon() {
		return icon; 
	}

	public boolean handleEvent(Event evt) {
		boolean b = super.handleEvent(evt);
		if (XFDesignOptions.designMode == XFDesignConstants.DM_REAL)
			return b;
		return b;
	}

	private boolean propertyDefault(int i) throws XFPropertyIndexOutOfBoundsException {
		if (propDefSet)
			propertiesSetDefault();
		if (propDef[i] == null)
			return false;
		switch (i) {
			case 0: return ((Color) propDef[i]).equals(text.getBackground());
			case 1: return ((Color) propDef[i]).equals(text.getForeground());
			case 2: return (((Boolean) propDef[i]).booleanValue() == text.isEnabled());
			case 3: return (((Boolean) propDef[i]).booleanValue() == bVisible);
			case 4: return ((Font) propDef[i]).equals(text.getFont());
			case 5: return ((String) propDef[i]).equals(text.getText());
			case 6: return (((Boolean) propDef[i]).booleanValue() == autoSize);
			case 7: return (((Boolean) propDef[i]).booleanValue() == parentColor);
			case 8: return (((Boolean) propDef[i]).booleanValue() == parentFont);
			case 9: return (((Integer) propDef[i]).intValue() == text.getSelectionStart());
			case 10: return (((Integer) propDef[i]).intValue() == text.getSelectionEnd());
			case 11: return (((Boolean) propDef[i]).booleanValue() == text.isEditable());
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	private void propertiesSetDefault() {
		if (propDefSet)
			return;
		propDefSet = true;
		if (text.getBackground() != null)
				propDef[0] = new Color(text.getBackground().getRGB());
		if (text.getForeground() != null)
				propDef[1] = new Color(text.getForeground().getRGB());
		propDef[2] = new Boolean(text.isEnabled());
		propDef[3] = new Boolean(bVisible);
		if (text.getFont() != null)
			propDef[4] = new Font(text.getFont().getName(),text.getFont().getStyle(),text.getFont().getSize());
		propDef[5] = new String("");
		propDef[6] = new Boolean(autoSize);
		propDef[7] = new Boolean(parentColor);
		propDef[8] = new Boolean(parentFont);
		propDef[9] = new Integer(text.getSelectionStart());
		propDef[10] = new Integer(text.getSelectionEnd());
		propDef[11] = new Boolean(text.isEditable());
	}

	public int getPropertyCount() { return propertyCount; }
	
	public Object getProperty(int index) throws XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: return text.getBackground();
			case 1: return text.getForeground();
			case 2: return (text.isEnabled()) ? Boolean.TRUE : Boolean.FALSE;
			case 3: return (bVisible) ? Boolean.TRUE : Boolean.FALSE;
			case 4: return text.getFont();
			case 5: return text.getText();
			case 6: return (autoSize) ? Boolean.TRUE : Boolean.FALSE;
			case 7: return (parentColor) ? Boolean.TRUE : Boolean.FALSE;
			case 8: return (parentFont) ? Boolean.TRUE : Boolean.FALSE;
			case 9: return new Integer(text.getSelectionStart());
			case 10: return new Integer(text.getSelectionEnd());
			case 11: return (text.isEditable()) ? Boolean.TRUE : Boolean.FALSE;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}
			
	public String[] getPropertyNames() { 
		String list[] = new String[propertyCount];
		list[0] = "Background Color";
		list[1] = "Foreground Color";
		list[2] = "Enabled";
		list[3] = "Visible";
		list[4] = "Font";
		list[5] = "Text";
		list[6] = "Auto Size";
		list[7] = "Parent Color";
		list[8] = "Parent Font";
		list[9] = "Selection Start";
		list[10] = "Selection End";
		list[11] = "Editable";
		return list;
	}
		
	public String getPropertyString(int index) throws 
		XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: 
			case 1: return XColorPropertyType.viewString(getProperty(index));
			case 2:
			case 3: return XBooleanPropertyType.viewString(getProperty(index));
			case 4: return XFontPropertyType.viewString(getProperty(index));
			case 5: return XMultiLineStringPropertyType.viewString(getProperty(index));
			case 6: 
			case 7: 
			case 8: return XBooleanPropertyType.viewString(getProperty(index));
			case 9:
			case 10: return XIntegerPropertyType.viewString(getProperty(index));
			case 11: return XBooleanPropertyType.viewString(getProperty(index));
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int getPropertyViewerType(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: 
			case 1: return XFDesignConstants.PVT_SPECIAL;
			case 2:
			case 3: return XFDesignConstants.PVT_CHECK;
			case 4: return XFDesignConstants.PVT_SPECIAL;
			case 5: return XFDesignConstants.PVT_SPECIAL;
			case 6: 
			case 7: 
			case 8: return XFDesignConstants.PVT_CHECK;
			case 9:
			case 10: return XFDesignConstants.PVT_INPUT_INT;
			case 11: return XFDesignConstants.PVT_CHECK;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public String[] getPropertyValueNames(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public Object[] getPropertyValueValues(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int setProperty(int index, Object value) throws 	
		XFPropertyIndexOutOfBoundsException,
		XFPropertyBadValueTypeException 
	{ 
		int ret = XFDesignConstants.RSP_OK;
		int regen = XFDesignConstants.GEN_SETPROPS;
		if (!propDefSet)
			propertiesSetDefault();
		switch (index) { 
			case 0: if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					text.setBackground((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					text.hide();
					text.show();
					if (parentColor) {
						parentColor = false;
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					break;
			case 1:	if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					text.setForeground((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					text.hide();
					text.show();
					if (parentColor) {
						parentColor = false;
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					break;
			case 2:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					text.enable(((Boolean)value).booleanValue());
					break;
			case 3: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					bVisible = ((Boolean)value).booleanValue();
					break;
			case 4: if (!(value instanceof Font)) throw new XFPropertyBadValueTypeException();
					text.setFont((Font)value); 
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP | XFDesignConstants.RSP_OTHER_PROP;
					if (parentFont) {
						parentFont = false;
						if (autoSize) {
							setDesignSize(0,0);
							regen = regen | XFDesignConstants.GEN_RESHAPE;
						}
					}
					repaintComponent();
					break;
			case 5: if (!(value instanceof String)) throw new XFPropertyBadValueTypeException();
					text.setText((String)value);
					if (autoSize) {
						setDesignSize(0,0);
						regen = regen | XFDesignConstants.GEN_RESHAPE;
						ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						repaintComponent();
					}
					break;
			case 6:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setAutoSize(((Boolean)value).booleanValue());
					if (autoSize) {
						repaintComponent();
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					regen = regen | XFDesignConstants.GEN_RESHAPE;
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 7:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setParentColor(((Boolean)value).booleanValue());
					if (parentColor)
						ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 8: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setParentFont(((Boolean)value).booleanValue());
					if (parentFont)
						ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (autoSize)
					 	ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					break;
			case 9: if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					text.select(((Integer)value).intValue(), text.getSelectionEnd());
					ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					break;
			case 10: if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					text.select(text.getSelectionStart(), ((Integer)value).intValue());
					ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					break;
			case 11: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					text.setEditable(((Boolean)value).booleanValue());
					break;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
		regenForm(regen);
		
		return ret;
	}
			
	public void specialPropertyInput(Frame parent, int index) throws 	
		XFPropertyIndexOutOfBoundsException, 
		XFPropertyNoSpecialInputException { 
		if ((index < 0) || (index >= propertyCount)) throw new XFPropertyIndexOutOfBoundsException();
		switch (index) { 
			case 0:
			case 1: XColorPropertyType.invokeSpecialInput(parent, this, index);
						break;
			case 4: XFontPropertyType.invokeSpecialInput(parent, this, index);
						break;
			case 5: XMultiLineStringPropertyType.invokeSpecialInput(parent, this, index);
						break;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int getEventCount() {
		return eventCount;
	}

	public String[] getEventNames() {
		String list[] = new String[eventCount];
		list[0] = "OnGotFocus";
		list[1] = "OnLostFocus";
		list[2] = "OnKeyAction";
		list[3] = "OnKeyActionRelease";
		list[4] = "OnPress";
		list[5] = "OnRelease";
		return list;
	}

	public String getEvent(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount)) {
			if (events[index] == null)
				return null;
			else
				return new String(events[index]); 
		}
		else throw new XFPropertyIndexOutOfBoundsException();
	}		
		
	public void setEvent(int index, String value) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount))
			events[index] = value;
		else throw new XFPropertyIndexOutOfBoundsException();
	}		

	public String getClassName() {
		return "TextArea";
	}
	
	public String generateCode(int what) {
		String gen = "";
		switch (what) {
			case XFDesignConstants.GEN_VARIABLE: 
				gen = getClassName()+" "+ name + ";\n";
				break;
			case XFDesignConstants.GEN_INIT: 
				gen = name + " = new " + getClassName() + "();\n";
				break;
			case XFDesignConstants.GEN_SETPROPS:
				if (!propDefSet)
					propertiesSetDefault();
				for (int i = 0; i < propertyCount; i++) {
					if (!propertyDefault(i)) {
						switch(i) {
							case 0: if (!parentColor)
										gen = gen + name + ".setBackground(" +
											XFDesignUtils.genColor(text.getBackground()) + ");\n";
									break;
							case 1: if (!parentColor)
										gen = gen + name + ".setForeground(" +
											XFDesignUtils.genColor(text.getForeground()) + ");\n";
									break;
							case 2: gen = gen + name + (text.isEnabled() ? ".enable();\n" : ".disable();\n");
									break;
							case 3: gen = gen + name + ((bVisible) ? ".show();\n" : ".hide();\n");
									break;
							case 4: if (!parentFont) {
										gen = gen + name + ".setFont(" + 
											XFDesignUtils.genFont(text.getFont())+");\n";
									}
									break;
							case 5: String t = text.getText();
									StringBuffer convert = new StringBuffer();
									char c;
									for (int j = 0; j < t.length(); j++) {
										c = t.charAt(j);
										if (c == '\n')
											convert.append("\\n\" +\n" + XFDesignOptions.indent(2) + "\""); // :-)
										else
											convert.append(c);
									}
									gen = gen + name + ".setText(\"" + convert + "\");\n";
									break;
							case 9: 
							case 10: if ((i == 9) || ((i == 10) && (!propertyDefault(9))))
										if (text.getSelectionStart() != text.getSelectionEnd())
											gen = gen + name + ".select(" + text.getSelectionStart() +
												"," + text.getSelectionEnd() + ");\n";
									break;
							case 11: gen = gen + name + ".setEditable(" + text.isEditable() + ");\n";
									break;

						}
					}
				}
				break;			
			case XFDesignConstants.GEN_RESHAPE:
				if (((XelfiVisualContainer) getParent()).getDesignLayout().allowsDragging()) {
					if (!autoSize) 
						if (getParent() instanceof XelfiDesignForm)
							gen = name + ".reshape(insets.left+"+position.x+", insets.top+"+position.y+","+size.width+","+size.height+");\n";
						else 
							gen = name + ".reshape("+position.x+","+position.y+","+size.width+","+size.height+");\n";
					else {
						gen = name + ".resize(" + name + ".preferredSize());\n";
						if (getParent() instanceof XelfiDesignForm)
							gen = gen + name + ".move(insets.left+"+position.x+", insets.top+"+position.y+");\n";
						else
							gen = gen + name + ".move("+position.x+","+position.y+");\n";
					}
				}
				break;
		}
		return gen;
	}

	public String generateEventCondition(int index) throws XFPropertyIndexOutOfBoundsException {
		String evt = XFDesignOptions.eventVarName;
		switch (index) { 
			case 0: return evt +".id == Event.GOT_FOCUS && "+evt+".target == "+getName();
			case 1: return evt +".id == Event.LOST_FOCUS && "+evt+".target == "+getName();
			case 2: return evt +".id == Event.KEY_ACTION && "+evt+".target == "+getName();
			case 3: return evt +".id == Event.KEY_ACTION_RELEASE && "+evt+".target == "+getName();
			case 4: return evt +".id == Event.KEY_PRESS && "+evt+".target == "+getName();
			case 5: return evt +".id == Event.KEY_RELEASE && "+evt+".target == "+getName();
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public void loadFromStream(DataInput stream) throws IOException {

		super.loadFromStream(stream);

		if (!propDefSet)
			propertiesSetDefault();

		for (int i = 0; i < propertyCount; i++) {
			if (stream.readBoolean()) {
				propDef[i] = null;
			}
			else switch (i) {
				case 0: text.setBackground(XColorPropertyType.loadFromStream(stream)); break;
				case 1: text.setForeground(XColorPropertyType.loadFromStream(stream)); break;
				case 2: text.enable(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 3: bVisible = XBooleanPropertyType.loadBFromStream(stream); break;
				case 4: text.setFont(XFontPropertyType.loadFromStream(stream)); break;
				case 5: text.setText(XStringPropertyType.loadFromStream(stream)); break;
				case 6: setAutoSize(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 7: setParentColor(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 8: setParentFont(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 9: text.select(((Integer) XIntegerPropertyType.loadFromStream(stream)).intValue(), text.getSelectionEnd()); break;
				case 10: text.select(text.getSelectionStart(), ((Integer)XIntegerPropertyType.loadFromStream(stream)).intValue()); break;
				case 11: text.setEditable(XBooleanPropertyType.loadBFromStream(stream)); break;
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if (stream.readBoolean())
				parentForm.assignEvent(this, i, stream.readUTF());
		}
	}		
	
	public void saveToStream(DataOutput stream) throws IOException {

		super.saveToStream(stream);

		for (int i = 0; i < propertyCount; i++) {
			boolean b = propertyDefault(i);
			stream.writeBoolean(b);
			if (!b) {
				switch (i) {
					case 0: XColorPropertyType.saveToStream(text.getBackground(), stream); break;
					case 1: XColorPropertyType.saveToStream(text.getForeground(), stream); break;
					case 2: XBooleanPropertyType.saveToStream(text.isEnabled(), stream); break;
					case 3: XBooleanPropertyType.saveToStream(bVisible, stream); break;
					case 4: XFontPropertyType.saveToStream(text.getFont(), stream); break;
					case 5: XStringPropertyType.saveToStream(text.getText(), stream); break;
					case 6: XBooleanPropertyType.saveToStream(autoSize, stream); break;
					case 7: XBooleanPropertyType.saveToStream(parentColor, stream); break;
					case 8: XBooleanPropertyType.saveToStream(parentFont, stream); break;
					case 9: XIntegerPropertyType.saveToStream(new Integer(text.getSelectionStart()), stream); break;
					case 10: XIntegerPropertyType.saveToStream(new Integer(text.getSelectionEnd()), stream); break;
					case 11: XBooleanPropertyType.saveToStream(text.isEditable(), stream); break;
				}
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if ((events[i] != null) && (events[i].length() > 0)) {
				stream.writeBoolean(true);
				stream.writeUTF(events[i]);
			}
			else stream.writeBoolean(false);
		}
	}
	
}