package xelfi.design.inspector;

import xelfi.util.Debug;

/**
 * Thread which performs the work of changing the selection
 * in Component inspector.
	Last change:  DF   21 Dec 96   11:33 pm
*/
class PageThread extends Thread {
	// component inspector object
	XFComponentInspector					ci;
	Thread												waitFor;

	PageThread (XFComponentInspector ci, Thread waitFor) {
		this.ci = ci;
		this.waitFor = waitFor;
		// set ourself on nice level (lowest priority)
		setPriority(Thread.MIN_PRIORITY);
	}

	public void run () {
		if (ci==null) return;
		// forces change of the page in ci - but waits for change of inspectable,
		// if this is the case
/*		if (waitFor!=null)
			join(waitFor); */
//		Debug.debug(Debug.INSPECTOR, "page thread started....");
		ci.doPageChanged();
//		Debug.debug(Debug.INSPECTOR, "page thread ended....");
	}
}

