package xelfi.design.inspector;

import xelfi.util.Debug;

/**
 * Thread which performs the work of time-consuming operations
 * in Component inspector.
	Last change:  DF   29 Jan 97   10:39 pm
*/
class SelectionThread extends Thread {
	// component inspector object
	XFComponentInspector					ci;

	SelectionThread (XFComponentInspector ci) {
		this.ci = ci;
		// set ourself on nice level (lowest priority)
		setPriority(Thread.MIN_PRIORITY);
	}

	public void run () {
		if (ci==null) return;
		// starts to do some time-consuming operation on component inspector
		// through sync object
		selectionChanged();
	}

	private void selectionChanged () {
		ci.doSelectionChanged();
//		sync.selectionChanged();
	}

}

