/**
* Xelfi
*/

package xelfi.design.util;

import java.awt.Image;

/**
 * @version 	1.02, 25 Feb 1997
 * @author 	Ian Formanek
 */

public class GridInfo {
	public Image gridImage = null;
	public int imWidth = -1, imHeight = -1;

	private int gx, gy;

	public GridInfo (int aGx, int aGy) {
		gx = aGx; if (gx <1) gx = 1;
		gy = aGy; if (gy <1) gy = 1;
	}
	
	public void setGrid(int aGx, int aGy) {
		if (aGx == gx && aGy == gy) return;
		gx = aGx; if (gx <1) gx = 1;
		gy = aGy; if (gy <1) gy = 1;
		invalidate();
	}

	public int gridX() { return gx; }
	public int gridY() { return gy; }

	public void invalidate() {
		gridImage = null;
		imWidth = -1; imHeight = -1;
	}

	public String toString() {
		return "GridInfo [gridX: "+gx+", gridY: "+gy+", imWidth: "+
			imWidth+", imHeight: "+imHeight+"Image: "+gridImage+"]";
	}
}
