/**
* Xelfi programming environment
*/

package xelfi.editor;
/**
* Contains name of source and line number.
*
* @version 1.0
* @author Jaroslav Tulach
*/
public class PositionInfo extends Object {
  private Source source;
  private int line;

  /** Creates new info.
  * @param n the source class
  * @param l the line number in the file
  */
  public PositionInfo (Source s, int l) {
    source = s;
    line = l;
  };

  /** The source object of class.
  * @return the name
  */
  public Source getSource () {
    return source;
  };

  /** The line in sources.
  * @return the line
  */
  public int getLine () {
    return line;
  };
};


