/**
* Xelfi Environment
*/

package xelfi.editor.keys;
import xelfi.editor.*;
import java.util.*;

/** Concatenates more handlers to one
*
* @author Jaroslav Tulach
* @version 1.0
*/
class KeyActionMacro extends Vector implements KeyActionHandler {
  /**
  * @param s initial size
  */
  public KeyActionMacro (int s) {
    super (s);
  }

  /** Initialization is already done.
  * @param v vector of parameters. It can contain objects of type
  *   String, Integer, Character.
  * @exception IllegalArgumentException if a parameter is not valid
  */
  public void init (Vector v) {
  };

  /** Reacts to a key.
  * @param key the key code that occured
  * @param modifiers the state of modifiers
  * @param info info about editor
  * @return true if next command should be excecuted, false if
  *   the action should stop. Macro always returns true!
  * @exception NotAllowedException if the action is not allowed
  * @exception EndOfTextException if end of text is reached
  */
  public boolean keyDown (int key, int modifiers, TextEditorInfo info)
  throws NotAllowedException, EndOfTextException {
    Enumeration en = elements ();
    while (en.hasMoreElements ()) {
      KeyActionHandler h = (KeyActionHandler)en.nextElement ();
      if (!h.keyDown (key, modifiers, info)) break;
    };
    return true;
  };

}




// Generated from substitution template 'Class' Blocks:Class:9,17,23,17; Class:6,13,20,13; Package:8,4,25,4; 
